ru.bitel.bgbilling.kernel.contract.api.common.service

## Interface ContractParameterService

-     public interface ContractParameterService

  Справочник параметров.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `contractParameterGroupAttrDelete(int id)` Удаление параметра договора из справочника.
    `ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroupAttr` | `contractParameterGroupAttrGet(int id)` Получение типа параметра по ID из справочника параметров.
    `java.util.List<ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroupAttr>` | `contractParameterGroupAttrList()` Получение списка параметров договора из справочника.
    `int` | `contractParameterGroupAttrUpdate(ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroupAttr attr)` Добавление/обновление параметра договора справочника.
    `void` | `contractParameterGroupDelete(int id)` Удаление группы параметров по его ID.
    `ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroup` | `contractParameterGroupGet(int id)` Получение группы параметров договора по ID.
    `java.util.List<ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroup>` | `contractParameterGroupList()` Получение списка групп параметров договора.
    `int` | `contractParameterGroupUpdate(ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroup group)` Обновление группы параметров.
    `void` | `contractParameterGroupUpdateLink(int contractParameterGroupId, java.util.Set<java.lang.Integer> parameterIds)` Обновление привязки параметров к группе.
    `void` | `contractParameterListItemDelete(int parameterTypeId, int id)` Удаление значения спискового параметра.
    `java.util.List<ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterListItem>` | `contractParameterListItemList(int parameterTypeId)` Получение значений спискового параметра.
    `int` | `contractParameterListItemUpdate(int parameterTypeId, ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterListItem item)` Обновление значения спискового параметра.

- - ### Method Detail

    - #### contractParameterGroupGet

          ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroup contractParameterGroupGet(int id)
                                                                                                                 throws ru.bitel.bgbilling.common.BGException,
                                                                                                                        ru.bitel.bgbilling.common.BGMessageException,
                                                                                                                        ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                                                                                                        ru.bitel.bgbilling.common.BGIllegalAccessException

      Получение группы параметров договора по ID. Внутри него содержится список параметров справочника.
      Parameters:
        `id` - ID группы параметров.
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterGroupList

          java.util.List<ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroup> contractParameterGroupList()
                                                                                                                                  throws ru.bitel.bgbilling.common.BGException,
                                                                                                                                         ru.bitel.bgbilling.common.BGMessageException,
                                                                                                                                         ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                                                                                                                         ru.bitel.bgbilling.common.BGIllegalAccessException

      Получение списка групп параметров договора. Внутри каждой группы содержится список параметров справочника.
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`
      See Also:
        `ContractParameterGroup}`

    - #### contractParameterGroupUpdate

          int contractParameterGroupUpdate(ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroup group)
                                    throws ru.bitel.bgbilling.common.BGException,
                                           ru.bitel.bgbilling.common.BGMessageException,
                                           ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                           ru.bitel.bgbilling.common.BGIllegalAccessException

      Обновление группы параметров.
      Parameters:
        `group` - группа параметров
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterGroupDelete

          void contractParameterGroupDelete(int id)
                                     throws ru.bitel.bgbilling.common.BGException,
                                            ru.bitel.bgbilling.common.BGMessageException,
                                            ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                            ru.bitel.bgbilling.common.BGIllegalAccessException

      Удаление группы параметров по его ID.
      Parameters:
        `id` - ID группы параметров
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterListItemList

          java.util.List<ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterListItem> contractParameterListItemList(int parameterTypeId)
                                                                                                                                        throws ru.bitel.bgbilling.common.BGException,
                                                                                                                                               ru.bitel.bgbilling.common.BGMessageException,
                                                                                                                                               ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                                                                                                                               ru.bitel.bgbilling.common.BGIllegalAccessException

      Получение значений спискового параметра.
      Parameters:
        `parameterTypeId` - pid
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterListItemUpdate

          int contractParameterListItemUpdate(int parameterTypeId,
                                              ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterListItem item)
                                       throws ru.bitel.bgbilling.common.BGException,
                                              ru.bitel.bgbilling.common.BGMessageException,
                                              ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                              ru.bitel.bgbilling.common.BGIllegalAccessException

      Обновление значения спискового параметра.
      Parameters:
        `parameterTypeId` - pid
        `item` - значение
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterListItemDelete

          void contractParameterListItemDelete(int parameterTypeId,
                                               int id)
                                        throws ru.bitel.bgbilling.common.BGException,
                                               ru.bitel.bgbilling.common.BGMessageException,
                                               ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                               ru.bitel.bgbilling.common.BGIllegalAccessException

      Удаление значения спискового параметра.
      Parameters:
        `parameterTypeId` - pid
        `id` - значения
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterGroupAttrGet

          ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroupAttr contractParameterGroupAttrGet(int id)
                                                                                                                         throws ru.bitel.bgbilling.common.BGException,
                                                                                                                                ru.bitel.bgbilling.common.BGMessageException,
                                                                                                                                ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                                                                                                                ru.bitel.bgbilling.common.BGIllegalAccessException

      Получение типа параметра по ID из справочника параметров.
      Parameters:
        `id` - ID типа параметра договора
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterGroupAttrList

          java.util.List<ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroupAttr> contractParameterGroupAttrList()
                                                                                                                                          throws ru.bitel.bgbilling.common.BGException,
                                                                                                                                                 ru.bitel.bgbilling.common.BGMessageException,
                                                                                                                                                 ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                                                                                                                                 ru.bitel.bgbilling.common.BGIllegalAccessException

      Получение списка параметров договора из справочника.
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterGroupAttrUpdate

          int contractParameterGroupAttrUpdate(ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterGroupAttr attr)
                                        throws ru.bitel.bgbilling.common.BGException,
                                               ru.bitel.bgbilling.common.BGMessageException,
                                               ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                               ru.bitel.bgbilling.common.BGIllegalAccessException

      Добавление/обновление параметра договора справочника.
      Parameters:
        `attr` -
      Returns:
        ID созданного/обновленного параметра
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterGroupAttrDelete

          void contractParameterGroupAttrDelete(int id)
                                         throws ru.bitel.bgbilling.common.BGException,
                                                ru.bitel.bgbilling.common.BGMessageException,
                                                ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                                ru.bitel.bgbilling.common.BGIllegalAccessException

      Удаление параметра договора из справочника.
      Parameters:
        `id` - ID удаляемого параметра справочника
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`

    - #### contractParameterGroupUpdateLink

          void contractParameterGroupUpdateLink(int contractParameterGroupId,
                                                java.util.Set<java.lang.Integer> parameterIds)
                                         throws ru.bitel.bgbilling.common.BGException,
                                                ru.bitel.bgbilling.common.BGMessageException,
                                                ru.bitel.bgbilling.common.BGIllegalArgumentException,
                                                ru.bitel.bgbilling.common.BGIllegalAccessException

      Обновление привязки параметров к группе.
      Parameters:
        `contractParameterGroupId` - ID группы параметров, к которой будут привязаны параметры
        `parameterIds` - ID параметров, которые будут привязаны к группе
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`
        `ru.bitel.bgbilling.common.BGIllegalArgumentException`
        `ru.bitel.bgbilling.common.BGIllegalAccessException`